/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.email.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.email.entity.EmailVorlage;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractEmailVorlageSearch {

  @Inject
  protected transient EmailVorlageExtendedDAO dao;

  public AbstractEmailVorlageSearch() {
    super();
  }

  public List<EmailVorlage> getSearchResult(EmailVorlageSearchParameters searchParameters, EagerLoadingCollector<EmailVorlage> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<EmailVorlage> querySearchResult(EmailVorlageSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
